﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ComboBoxSelectEvent
{
    public partial class Form1 : Form
    {
        string[] customerList = new string[] { "Customer1", "Customer2", "Customer3", "Customer4" };
        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.cbCustomer.DataSource = customerList;
            this.cbCustomer.Leave+=new EventHandler(cbCustomer_Leave);
            this.cbCustomer.Enter+=new EventHandler(cbCustomer_Enter);
            this.cbCustomer.SelectedIndexChanged+=new EventHandler(cbCustomer_SelectedIndexChanged);
            this.cbCustomer.ComboBoxElement.Text = " --- Select Customer --- ";

        }

        private void cbCustomer_SelectedIndexChanged(object sender, EventArgs e)
        {
            MessageBox.Show("cbCustomer_SelectedIndexChanged fired.");
            var custID = this.cbCustomer.SelectedValue;
            if (this.cbCustomer.SelectedText == " --- Select Customer ---") return;
            //this.tT_OnlineDataSet.EnforceConstraints = false;
            //this.orderHeadTableAdapter.FillOrderByCustomerID(tT_OnlineDataSet.OrderHead, custID);
            //this.tT_OnlineDataSet.EnforceConstraints = true;
        }

        private void cbCustomer_Leave(object sender, EventArgs e)
        {
            this.cbCustomer.ComboBoxElement.Text = " --- Select Customer --- ";
            this.cbCustomer.ComboBoxElement.ForeColor = Color.LightGray;
        }

        private void cbCustomer_Enter(object sender, EventArgs e)
        {
            this.cbCustomer.ComboBoxElement.Text = "";
            this.cbCustomer.ComboBoxElement.ForeColor = Color.Empty;
        }

        private void buttonReserCustomer_Click(object sender, EventArgs e)
        {
            this.cbCustomer.SelectedIndexChanged -= new EventHandler(cbCustomer_SelectedIndexChanged);//unsubscribe for SelectedIndexChanged event
            this.cbCustomer.SelectedIndex = -1;
            this.cbCustomer.SelectedIndexChanged += new EventHandler(cbCustomer_SelectedIndexChanged);//subscribe for SelectedIndexChanged event
        }
    }
}
